// ============================================================
// marginal_PlayerSetupClient: eliminates maximum players to choose...
// Psychic_313: adapted from UsAaR33's olUTPlayerSetupClient.
// Re-introduced maxima (I can see why Epic added them) but
// made them configurable in MarginallyEnhancedUT.ini
// ============================================================

class PlayerSetupClient expands UTtPlayerSetupClient;

function LoadClasses()
{
	local int NumPlayerClasses;
	local string NextPlayer, NextDesc;

	GetPlayerOwner().GetNextIntDesc("TournamentPlayer", 0, NextPlayer, NextDesc);
	while( (NextPlayer != "") && NumPlayerClasses < class'MarginallyEnhancedUT'.default.PlayerClassLimit )
	{
		if (class'Ladder'.Default.HasBeatenGame || class'MarginallyEnhancedUT'.default.bRespectHasBeatenGame || !(NextPlayer ~= "Botpack.TBoss"))
			ClassCombo.AddItem(NextDesc, NextPlayer, 0);

		NumPlayerClasses++;
		GetPlayerOwner().GetNextIntDesc("TournamentPlayer", NumPlayerClasses, NextPlayer, NextDesc);
	}

	ClassCombo.Sort();
}

function IterateVoices()     //do not require ladder defeat.
{
	local int NumVoices;
	local string NextVoice, NextDesc;
	local string VoicepackMetaClass;
	local bool OldInitialized;

	OldInitialized = Initialized;
	Initialized = False;
	VoicePackCombo.Clear();
	Initialized = OldInitialized;

	if(ClassIsChildOf(NewPlayerClass, class'TournamentPlayer'))
		VoicePackMetaClass = class<TournamentPlayer>(NewPlayerClass).default.VoicePackMetaClass;
	else
		VoicePackMetaClass = "Botpack.ChallengeVoicePack";

	// Load the base class into memory to prevent GetNextIntDesc crashing as the class isn't loadded.
	DynamicLoadObject(VoicePackMetaClass, class'Class');

	GetPlayerOwner().GetNextIntDesc(VoicePackMetaClass, 0, NextVoice, NextDesc);
	while ( (NextVoice != "") && numvoices < class'marginallyenhancedUT'.default.PlayerVoiceLimit )
	{
		VoicePackCombo.AddItem(NextDesc, NextVoice, 0);
		numvoices++;
		GetPlayerOwner().GetNextIntDesc(VoicePackMetaClass, NumVoices, NextVoice, NextDesc);
	}

	VoicePackCombo.Sort();
}
defaultproperties
{
}
