class uplayersetupclient extends UMenuDialogClientWindow;

//replace all mention of "faces", we only want to load what we can for 1 2 3 4 5
//[4] aka skin5 is always the talktexture, but the others can mix up to anything 

var() int ControlOffset;

var class<Pawn> NewPlayerClass;
var string MeshName;
var bool Initialized;
var UMenuPlayerMeshClient MeshWindow;
var string PlayerBaseClass;

// Player Name
var UWindowEditControl NameEdit;
var localized string NameText;
var localized string NameHelp;


/* Team Combo
var UWindowComboControl TeamCombo;
var localized string TeamText;
var localized string Teams[4];
var localized string NoTeam;
var localized string TeamHelp;
*/

// Class Combo
var UWindowComboControl ClassCombo;
var localized string ClassText;
var localized string ClassHelp;


// Skin1 Combo
var UWindowComboControl SkinCombo1;
var localized string SkinText;
//var localized string SkinHelp;

// Skin2 Combo
var UWindowComboControl SkinCombo2;
//var localized string SkinText2;
//var localized string SkinHelp;

// Skin3 Combo
var UWindowComboControl SkinCombo3;
//var localized string SkinText3;
//var localized string SkinHelp;


// Skin4 Combo
var UWindowComboControl SkinCombo4;
//var localized string SkinText4;
//var localized string SkinHelp;


// Skin5 Combo  [4]/TALK TEXTURE
var UWindowComboControl SkinCombo5;
//var localized string SkinText5;
//var localized string SkinHelp;

// old face Combo
//var UWindowComboControl FaceCombo;
//var localized string FaceText;
//var localized string FaceHelp;



function Created()
{
	local string SkinName, FaceName;

	local int ControlWidth, ControlLeft, ControlRight;
	local int CenterWidth, CenterPos;
	local int I;
	
	MeshWindow = UMenuPlayerMeshClient(UMenuPlayerClientWindow(ParentWindow.ParentWindow.ParentWindow).Splitter.RightClientWindow);

	Super.Created();

	ControlWidth = WinWidth/2.5;
	ControlLeft = (WinWidth/2 - ControlWidth)/2;
	ControlRight = WinWidth/2 + ControlLeft;

	CenterWidth = (WinWidth/4)*3;
	CenterPos = (WinWidth - CenterWidth)/2;

	NewPlayerClass = GetPlayerOwner().Class;

	// Player Name
	NameEdit = UWindowEditControl(CreateControl(class'UWindowEditControl', CenterPos, ControlOffset, CenterWidth, 1));
	NameEdit.SetText(NameText);
	NameEdit.SetHelpText(NameHelp);
	NameEdit.SetFont(F_Normal);
	NameEdit.SetNumericOnly(False);
	NameEdit.SetMaxLength(20);
	NameEdit.SetDelayedNotify(True);

	/* Team
	ControlOffset += 25;
	TeamCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, ControlOffset, CenterWidth, 1));
	TeamCombo.SetText(TeamText);
	TeamCombo.SetHelpText(TeamHelp);
	TeamCombo.SetFont(F_Normal);
	TeamCombo.SetEditable(False);
	TeamCombo.AddItem(NoTeam, String(255));
	for (I=0; I<4; I++)
		TeamCombo.AddItem(Teams[I], String(i));*/

	ControlOffset += 25;
	// Load Classes
	ClassCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, ControlOffset, CenterWidth, 1));
	ClassCombo.SetText(ClassText);
	ClassCombo.SetHelpText(ClassHelp);
	ClassCombo.SetEditable(False);
	ClassCombo.SetFont(F_Normal);

	// Skin1
	ControlOffset += 25;
	SkinCombo1 = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, ControlOffset, CenterWidth, 1));
	SkinCombo1.SetText("Multi-Skin #1");
	//SkinCombo.SetHelpText(SkinHelp);
	SkinCombo1.SetFont(F_Normal);
	SkinCombo1.SetEditable(False);
	// Skin2
	ControlOffset += 25;
	SkinCombo2 = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, ControlOffset, CenterWidth, 1));
	SkinCombo2.SetText("Multi-Skin #2");
	//SkinCombo.SetHelpText(SkinHelp);
	SkinCombo2.SetFont(F_Normal);
	SkinCombo2.SetEditable(False);
	// Skin3
	ControlOffset += 25;
	SkinCombo3 = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, ControlOffset, CenterWidth, 1));
	SkinCombo3.SetText("Multi-Skin #3");
	//SkinCombo.SetHelpText(SkinHelp);
	SkinCombo3.SetFont(F_Normal);
	SkinCombo3.SetEditable(False);
	
	// Skin4 
	ControlOffset += 25;
	SkinCombo4 = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, ControlOffset, CenterWidth, 1));
	SkinCombo4.SetText("Multi-Skin #4");
	//SkinCombo.SetHelpText(SkinHelp);
	SkinCombo4.SetFont(F_Normal);
	SkinCombo4.SetEditable(False);

	// Skin5 Talk Texture
	ControlOffset += 25;
	SkinCombo5 = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, ControlOffset, CenterWidth, 1));
	SkinCombo5.SetText("Talk Texture");
	//SkinCombo.SetHelpText(SkinHelp);
	SkinCombo5.SetFont(F_Normal);
	SkinCombo5.SetEditable(False);

	//old face
	//ControlOffset += 25;
	//FaceCombo = UWindowComboControl(CreateControl(class'UWindowComboControl', CenterPos, ControlOffset, CenterWidth, 1));
	//FaceCombo.SetText(FaceText);
	//FaceCombo.SetHelpText(FaceHelp);
	//FaceCombo.SetFont(F_Normal);
	//FaceCombo.SetEditable(False);



	LoadClasses();
}


function AfterCreate()
{
	Super.AfterCreate();

	DesiredWidth = 220;
	DesiredHeight = ControlOffset + 25;

	LoadCurrent();
	UseSelected();
		
	Initialized = True;
}

function LoadClasses()
{
	local int NumPlayerClasses;
	local string NextPlayer, NextDesc;
	local int SortWeight;

	GetPlayerOwner().GetNextIntDesc(PlayerBaseClass, 0, NextPlayer, NextDesc);
	while( (NextPlayer != "") && (NumPlayerClasses < 64) )
	{
		ClassCombo.AddItem(NextDesc, NextPlayer, SortWeight);
		NumPlayerClasses++;
		GetPlayerOwner().GetNextIntDesc(PlayerBaseClass, NumPlayerClasses, NextPlayer, NextDesc);
	}
	ClassCombo.Sort();
}

function LoadCurrent()
{
	local string SN, FN;

	NameEdit.SetValue(GetPlayerOwner().PlayerReplicationInfo.PlayerName);
	//TeamCombo.SetSelectedIndex(Max(TeamCombo.FindItemIndex2(string(GetPlayerOwner().PlayerReplicationInfo.Team)), 0));
	//is it even getting the right class?
	SkinCombo1.SetSelectedIndex(Max(SkinCombo1.FindItemIndex2(GetPlayerOwner().GetDefaultURL("Multiskin0"), True), 0));
	SkinCombo2.SetSelectedIndex(Max(SkinCombo2.FindItemIndex2(GetPlayerOwner().GetDefaultURL("Multiskin1"), True), 0));
	SkinCombo3.SetSelectedIndex(Max(SkinCombo3.FindItemIndex2(GetPlayerOwner().GetDefaultURL("Multiskin2"), True), 0));
	SkinCombo4.SetSelectedIndex(Max(SkinCombo4.FindItemIndex2(GetPlayerOwner().GetDefaultURL("Multiskin3"), True), 0));
	SkinCombo5.SetSelectedIndex(Max(SkinCombo5.FindItemIndex2(GetPlayerOwner().GetDefaultURL("Multiskin4"), True), 0));
	

	/*if(GetLevel().Game != None && GetLevel().Game.IsA('UTIntro'))
	{
		SN = GetPlayerOwner().GetDefaultURL("Skin");
		//FN = GetPlayerOwner().GetDefaultURL("Face");
		ClassCombo.SetSelectedIndex(Max(ClassCombo.FindItemIndex2(GetPlayerOwner().GetDefaultURL("Class"), True), 0));
	}
	else
	{
		ClassCombo.SetSelectedIndex(Max(ClassCombo.FindItemIndex2(string(GetPlayerOwner().Class), True), 0));
		GetPlayerOwner().static.GetMultiSkin(GetPlayerOwner(), SN, FN);
	}
	SkinCombo1.SetSelectedIndex(Max(SkinCombo1.FindItemIndex2(SN, True), 0));
	//SkinCombo5.SetSelectedIndex(Max(SkinCombo5.FindItemIndex2(FN, True), 0));
	*/
}

function SaveConfigs()
{
	Super.SaveConfigs();
	GetPlayerOwner().SaveConfig();
	GetPlayerOwner().PlayerReplicationInfo.SaveConfig();
}
//pasted from child class because function is also used here
/*old
function IterateSkins()
{

	local string SkinName, SkinDesc, TestName, Temp, FaceName;
	local int i;
	local bool bNewFormat;

	SkinCombo1.Clear();
	SkinCombo2.Clear();
	SkinCombo3.Clear();
	SkinCombo4.Clear();
	SkinCombo5.Clear();

	/*if( ClassIsChildOf(NewPlayerClass, class'Spectator') )
	{
		SkinCombo1.HideWindow();
		return;
	}
	else*/
		skincombo1.ShowWindow();

	bNewFormat = NewPlayerClass.default.bIsMultiSkinned;

	SkinName = "None";
	TestName = "";
	while ( i < class'MarginallyEnhancedUT'.default.PlayerTextureLimit )
	{
		GetPlayerOwner().GetNextSkin(MeshName, SkinName, 1, SkinName, SkinDesc);

		if( SkinName == TestName )
			break;

		if( TestName == "" )
			TestName = SkinName;

		if( SkinDesc != "")
		{
			Temp = GetPlayerOwner().GetItemName(SkinName);
			log("hmm "$Mid(Temp, 4, 1)$" - "$skinname$" - "$SkinDesc);
			switch (Mid(Temp, 4, 1))
			{
				case ("1"):
				if (texture(DynamicLoadObject(skinname, class'Texture')) != None) { skincombo1.AddItem(SkinDesc, skinname); }
				if (texture(DynamicLoadObject(skinname$"T_0", class'Texture')) != None) { skincombo1.AddItem(SkinDesc$" Red", skinname$"T_0"); }
				if (texture(DynamicLoadObject(skinname$"T_1", class'Texture')) != None) { skincombo1.AddItem(SkinDesc$" Blue", skinname$"T_1"); }
				if (texture(DynamicLoadObject(skinname$"T_2", class'Texture')) != None) { skincombo1.AddItem(SkinDesc$" Green", skinname$"T_2"); }
				if (texture(DynamicLoadObject(skinname$"T_3", class'Texture')) != None) { skincombo1.AddItem(SkinDesc$" Gold", skinname$"T_3"); }
			
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"2", class'Texture')) != None) { skincombo2.AddItem(SkinDesc, mid(skinname,0,len(skinname) -1)$"2"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"2T_0", class'Texture')) != None) { skincombo2.AddItem(SkinDesc$" Red", mid(skinname,0,len(skinname) -1)$"2T_0"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"2T_1", class'Texture')) != None) { skincombo2.AddItem(SkinDesc$" Blue", mid(skinname,0,len(skinname) -1)$"2T_1"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"2T_2", class'Texture')) != None) { skincombo2.AddItem(SkinDesc$" Green", mid(skinname,0,len(skinname) -1)$"2T_2"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"2T_3", class'Texture')) != None) { skincombo2.AddItem(SkinDesc$" Gold", mid(skinname,0,len(skinname) -1)$"2T_3"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"3", class'Texture')) != None) { skincombo3.AddItem(SkinDesc, mid(skinname,0,len(skinname) -1)$"3"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"3T_0", class'Texture')) != None) { skincombo3.AddItem(SkinDesc$" Red", mid(skinname,0,len(skinname) -1)$"3T_0"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"3T_1", class'Texture')) != None) { skincombo3.AddItem(SkinDesc$" Blue", mid(skinname,0,len(skinname) -1)$"3T_1"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"3T_2", class'Texture')) != None) { skincombo3.AddItem(SkinDesc$" Green", mid(skinname,0,len(skinname) -1)$"3T_2"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"3T_3", class'Texture')) != None) { skincombo3.AddItem(SkinDesc$" Gold", mid(skinname,0,len(skinname) -1)$"3T_3"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"4", class'Texture')) != None) { skincombo4.AddItem(SkinDesc, mid(skinname,0,len(skinname) -1)$"4"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"4T_0", class'Texture')) != None) { skincombo4.AddItem(SkinDesc$" Red", mid(skinname,0,len(skinname) -1)$"4T_0"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"4T_1", class'Texture')) != None) { skincombo4.AddItem(SkinDesc$" Blue", mid(skinname,0,len(skinname) -1)$"4T_1"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"4T_2", class'Texture')) != None) { skincombo4.AddItem(SkinDesc$" Green", mid(skinname,0,len(skinname) -1)$"4T_2"); }
				if (texture(DynamicLoadObject(mid(skinname,0,len(skinname) -1)$"4T_3", class'Texture')) != None) { skincombo4.AddItem(SkinDesc$" Gold", mid(skinname,0,len(skinname) -1)$"4T_3"); }


				break; case ("2"):
				if (texture(DynamicLoadObject(skinname, class'Texture')) != None) { skincombo2.AddItem(SkinDesc, skinname); }
				if (texture(DynamicLoadObject(skinname$"T_0", class'Texture')) != None) { skincombo2.AddItem(SkinDesc$" Red", skinname$"T_0"); }
				if (texture(DynamicLoadObject(skinname$"T_1", class'Texture')) != None) { skincombo2.AddItem(SkinDesc$" Blue", skinname$"T_1"); }
				if (texture(DynamicLoadObject(skinname$"T_2", class'Texture')) != None) { skincombo2.AddItem(SkinDesc$" Green", skinname$"T_2"); }
				if (texture(DynamicLoadObject(skinname$"T_3", class'Texture')) != None) { skincombo2.AddItem(SkinDesc$" Gold", skinname$"T_3"); }

				break; case ("3"):

				if (texture(DynamicLoadObject(skinname, class'Texture')) != None) { skincombo3.AddItem(SkinDesc, skinname); }
				if (texture(DynamicLoadObject(skinname$"T_0", class'Texture')) != None) { skincombo3.AddItem(SkinDesc$" Red", skinname$"T_0"); }
				if (texture(DynamicLoadObject(skinname$"T_1", class'Texture')) != None) { skincombo3.AddItem(SkinDesc$" Blue", skinname$"T_1"); }
				if (texture(DynamicLoadObject(skinname$"T_2", class'Texture')) != None) { skincombo3.AddItem(SkinDesc$" Green", skinname$"T_2"); }
				if (texture(DynamicLoadObject(skinname$"T_3", class'Texture')) != None) { skincombo3.AddItem(SkinDesc$" Gold", skinname$"T_3"); }


				break; case ("4"):
			
				if (texture(DynamicLoadObject(skinname, class'Texture')) != None) { skincombo4.AddItem(SkinDesc, skinname); }
				if (texture(DynamicLoadObject(skinname$"T_0", class'Texture')) != None) { skincombo4.AddItem(SkinDesc$" Red", skinname$"T_0"); }
				if (texture(DynamicLoadObject(skinname$"T_1", class'Texture')) != None) { skincombo4.AddItem(SkinDesc$" Blue", skinname$"T_1"); }
				if (texture(DynamicLoadObject(skinname$"T_2", class'Texture')) != None) { skincombo4.AddItem(SkinDesc$" Green", skinname$"T_2"); }
				if (texture(DynamicLoadObject(skinname$"T_3", class'Texture')) != None) { skincombo4.AddItem(SkinDesc$" Gold", skinname$"T_3"); }	
			}
			if (len(skinname) > 5)
			{ 
				
				//[4] aka skincombo5 = talktex
				//if (texture(DynamicLoadObject(skinname, class'Texture')) != None) { skincombo5.AddItem(SkinDesc, skinname); }
				//log("we have talk texture above (although idealy we want the actual talk textures with 5 in them)"); }
				//log(skinname$" - "$
			}

		}


		i++;
	}
	skincombo1.Sort(); skincombo2.Sort(); skincombo3.Sort();
}

function IterateFaces(string InSkinName)
{
	local string SkinName, SkinDesc, TestName, Temp, FaceName;
	local bool bNewFormat;

	log("sent iteratefaces with string "$inskinname);

	//FaceCombo.Clear();
	//SkinCombo5.Clear();
	// New format only
	/*if( !NewPlayerClass.default.bIsMultiSkinned )
	{
		FaceCombo.HideWindow();
		return;
	}
	else*/
		
		//SkinCombo5.ShowWindow();

	SkinName = "None";
	TestName = "";
	log("debug");
	while ( True )
	{
		log("debug #1 "$meshname$" - "$skinname);
//native(545) final function GetNextSkin( string Prefix, string CurrentSkin, int Dir, out string SkinName, out string SkinDesc );
            GetPlayerOwner().GetNextSkin(MeshName, SkinName, 1, SkinName, SkinDesc);

		if( SkinName == TestName )
			break;

		if( TestName == "" )
			TestName = SkinName;

		// Multiskin format
		//if( SkinDesc != "")
		//{	
		if (Mid(Temp, 4, 1) == "5")
		{
			Temp = GetPlayerOwner().GetItemName(SkinName);
			//if(Mid(Temp, 5) != "" && Left(Temp, 4) == GetPlayerOwner().GetItemName(InSkinName))
			//if (texture(DynamicLoadObject(skinname, class'Texture')) != None) { skincombo5.AddItem(SkinDesc, Left(SkinName, Len(SkinName) - Len(Temp)) $ Mid(Temp, 5)); }
			log("need to decode for text texture (below)");
			log("Skinname: "$skinname@Left(SkinName, Len(SkinName) - Len(Temp)) $ Mid(Temp, 5));
		}
	}
	//SkinCombo5.Sort();

}
*/

/************************************
*   NEW                             *
* skinname1 for retrieving textures *
* skinname2 is for loading textures *
* oldskindesc saves the description *
*	for colored ones	    *
************************************/

function IterateSkins(optional string InSkinName)
{
	local string SkinName, SkinName2, SkinDesc, TestName, Temp, FaceName, first, oldskindesc;
	//local bool bNewFormat;
	local bool binitiated;
	local int i;
	log("sent iteratefaces with string "$inskinname);

	SkinName = "None";
	TestName = "";
	SkinCombo1.Clear(); SkinCombo2.Clear(); SkinCombo3.Clear();  SkinCombo4.Clear();  SkinCombo5.Clear();
	while (( True ) && ( i < class'MarginallyEnhancedUT'.default.PlayerTextureLimit ))
	{
	
		//log("debug #1 "$meshname$" - "$skinname);
//native(545) final function GetNextSkin( string Prefix, string CurrentSkin, int Dir, out string SkinName, out string SkinDesc );
            GetPlayerOwner().GetNextSkin(MeshName, SkinName, 1, SkinName, SkinDesc);
	if (binitiated == false)
		{
			if (SkinDesc != "") { binitiated = True; log("start officially recording from here and set this as the double"); }
		}
		
		if ((skinname != "None") && (binitiated))
		{
			if (first == "") { log("setup first as "$skinname); first = skinname; } 
			else if (skinname == first) { log("double"); return; }
		} 

		//log("hmm "$Mid(meshname, 4, 1)$" - "$meshname$" - "$skinname$" - "$SkinDesc);
		//log(Mid(GetPlayerOwner().GetItemName(SkinName), 4, 1)$" "$GetPlayerOwner().GetItemName(SkinName));


		//SGirlSkins.fbth1_0 should be SGirlSkins.fbthT1_0 etc
		if (binitiated)
		 {
		/****************************************
		*	fix common broken skins		*
		****************************************/
		skinname2 = skinname;
		switch (skinname)
		{
			case ("SGirlSkins.fbth1_0"): skinname2 = "SGirlSkins.fbth1T_0"; break;
			case ("SGirlSkins.fbth1_1"): skinname2 = "SGirlSkins.fbth1T_1"; break;
			case ("SGirlSkins.fbth1_2"): skinname2 = "SGirlSkins.fbth1T_2"; break;
			case ("SGirlSkins.fbth1_3"): skinname2 = "SGirlSkins.fbth1T_3"; break;
			case ("FCommandoSkins.cmdo1_0"): skinname2 = "FCommandoSkins.cmdo1T_0"; break;
			case ("FCommandoSkins.cmdo1_1"): skinname2 = "FCommandoSkins.cmdo1T_1"; break;
			case ("FCommandoSkins.cmdo1_2"): skinname2 = "FCommandoSkins.cmdo1T_2"; break;
			case ("FCommandoSkins.cmdo1_3"): skinname2 = "FCommandoSkins.cmdo1T_3";
		}
		if (SkinDesc != "") { log(SkinDesc); }
		else { log("Name: "$skinname); }

		switch (Mid(GetPlayerOwner().GetItemName(SkinName), 4, 1))
		{
			case ("1"):
			//if (SkinDesc != "") { log(SkinDesc); }
			//else { log("Name: "$skinname); }
			if (texture(DynamicLoadObject(skinname2, class'Texture')) != None) 
			{
				if (SkinDesc != "") { skincombo1.AddItem(SkinDesc, skinname2); oldskindesc = skindesc; }
				//load colored ones
				else { skincombo1.AddItem(oldskindesc@n2color(right(skinname2,1)), skinname2); }
			}
			break; case ("2"):
			if (texture(DynamicLoadObject(skinname2, class'Texture')) != None) 
			{
				//This line is for when "2" is used for face textures
				if (SkinDesc != "") { skincombo2.AddItem(SkinDesc, skinname2); oldskindesc = skindesc; }
				//load colored ones
				else
				{
					if (len(GetPlayerOwner().GetItemName(SkinName2)) > 5) { skincombo2.AddItem(oldskindesc@n2color(right(skinname2,1)), skinname2); }
					else { skincombo2.AddItem(oldskindesc, skinname2); }
				}
			}
			break; case ("3"):
			if (texture(DynamicLoadObject(skinname2, class'Texture')) != None) 
			{
				if (SkinDesc != "") { skincombo3.AddItem(SkinDesc, skinname2); oldskindesc = skindesc; }
				//load colored ones
				else
				{
					if (len(GetPlayerOwner().GetItemName(SkinName2)) > 5) { skincombo3.AddItem(oldskindesc@n2color(right(skinname2,1)), skinname2); }
					else { skincombo3.AddItem(oldskindesc, skinname2); }
				}
			}
			break; case ("4"):
			if (texture(DynamicLoadObject(skinname2, class'Texture')) != None) 
			{
				if (SkinDesc != "") { skincombo4.AddItem(SkinDesc, skinname2); oldskindesc = skindesc; }
				//load colored ones
				else
				{
					if (len(GetPlayerOwner().GetItemName(SkinName2)) > 5) { skincombo4.AddItem(oldskindesc@n2color(right(skinname2,1)), skinname2); }
					else { skincombo4.AddItem(oldskindesc, skinname2); }
				}
			}
			break; case ("5"):
			//if (SkinDesc != "") { log(SkinDesc); }
			//else { log("Name: "$skinname); }
			if (texture(DynamicLoadObject(skinname2, class'Texture')) != None) 
			{
				//if (SkinDesc != "") { skincombo5.AddItem("1"$SkinDesc, skinname2); oldskindesc = skindesc; }
				//load colored ones
				//else
				//{
					if (len(GetPlayerOwner().GetItemName(SkinName2)) > 5) { skincombo5.AddItem(mid(GetPlayerOwner().GetItemName(SkinName2),5), skinname2); }
					//else { skincombo5.AddItem("2"$oldskindesc, skinname2); }
				//}
			}
		 }
		}


		i++;
	}
	SkinCombo1.Sort(); SkinCombo2.Sort(); SkinCombo3.Sort(); SkinCombo4.Sort(); SkinCombo5.Sort();

}
function string n2color(string s)
{
	switch (s)
	{
		case ("0"):  return "Red"; 
		case ("1"):  return "Blue"; 
		case ("2"):  return "Green"; 
		case ("3"):  return "Gold";
	}
}

function IterateFaces(string InSkinName)
{
}

function BeforePaint(Canvas C, float X, float Y)
{
	local int ControlWidth, ControlLeft, ControlRight;
	local int CenterWidth, CenterPos;
	local float W;

	W = Min(WinWidth, 220);

	ControlWidth = W/3;
	ControlLeft = (W/2 - ControlWidth)/2;
	ControlRight = W/2 + ControlLeft;

	CenterWidth = (W/7)*6;
	CenterPos = (W - CenterWidth)/2;

	NameEdit.SetSize(CenterWidth, 1);
	NameEdit.WinLeft = CenterPos;
	NameEdit.EditBoxWidth = 105;


	ClassCombo.SetSize(CenterWidth, 1);
	ClassCombo.WinLeft = CenterPos;
	ClassCombo.EditBoxWidth = 105;

	//TeamCombo.SetSize(CenterWidth, 1);
	//TeamCombo.WinLeft = CenterPos;
	//TeamCombo.EditBoxWidth = 105;

	SkinCombo1.SetSize(CenterWidth, 1);
	SkinCombo1.WinLeft = CenterPos;
	SkinCombo1.EditBoxWidth = 105;
	SkinCombo2.SetSize(CenterWidth, 1);
	SkinCombo2.WinLeft = CenterPos;
	SkinCombo2.EditBoxWidth = 105;
	SkinCombo3.SetSize(CenterWidth, 1);
	SkinCombo3.WinLeft = CenterPos;
	SkinCombo3.EditBoxWidth = 105;

	SkinCombo4.SetSize(CenterWidth, 1);
	SkinCombo4.WinLeft = CenterPos;
	SkinCombo4.EditBoxWidth = 105;

	//talk tex
	SkinCombo5.SetSize(CenterWidth, 1);
	SkinCombo5.WinLeft = CenterPos;
	SkinCombo5.EditBoxWidth = 105;



	//FaceCombo.SetSize(CenterWidth, 1);
	//FaceCombo.WinLeft = CenterPos;
	//FaceCombo.EditBoxWidth = 105;




}

function Notify(UWindowDialogControl C, byte E)
{
	Super.Notify(C, E);

	switch(E)
	{
		case DE_Change:
		switch(C)
		{
			case (NameEdit):
				NameChanged();
				break;
			//case TeamCombo:
			//	TeamChanged();
			//	break;
			case (ClassCombo):
				ClassChanged();
				break;
			case (SkinCombo1):
			case (SkinCombo2):
			case (SkinCombo3):
			case (SkinCombo4):
			case (SkinCombo5):
				SkinChanged(); 
//FaceChanged();
//UseSelected();
				break;


			//case FaceCombo:
			//	FaceChanged();
			//	break;
		}
	}
}

function NameChanged()
{
	local string N;
	if (Initialized)
	{
		Initialized = False;
		N = NameEdit.GetValue();
		ReplaceText(N, " ", "_");
		NameEdit.SetValue(N);
		Initialized = True;

		GetPlayerOwner().ChangeName(NameEdit.GetValue());
		GetPlayerOwner().UpdateURL("Name", NameEdit.GetValue(), True);
	}
}

/*function TeamChanged()
{
	if (Initialized)
		UseSelected();
}
*/
function SkinChanged()
{
	/*local bool OldInitialized;

	OldInitialized = Initialized;
	Initialized = False;
	IterateFaces(SkinCombo1.GetValue2());
	//FaceCombo.SetSelectedIndex(0);
	Initialized = OldInitialized;

	if (Initialized)
*/
		UseSelected();
}

function FaceChanged()
{
	//if (Initialized)
	//	UseSelected();
}

function ClassChanged()
{
	local string SkinName, SkinDesc;
	local bool OldInitialized;

	// Get the class.
	NewPlayerClass = class<Pawn>(DynamicLoadObject(ClassCombo.GetValue2(), class'Class'));

	// Get the meshname
	MeshName = GetPlayerOwner().GetItemName(String(NewPlayerClass.Default.Mesh));

	OldInitialized = Initialized;
	Initialized = False;

	IterateSkins();
	SkinCombo1.SetSelectedIndex(0);
SkinCombo1.SetSelectedIndex(0);
SkinCombo2.SetSelectedIndex(0);
SkinCombo3.SetSelectedIndex(0);
SkinCombo4.SetSelectedIndex(0);
	IterateFaces(SkinCombo1.GetValue2());
//SkinCombo5.SetSelectedIndex(0);

	//FaceCombo.SetSelectedIndex(0);
	Initialized = OldInitialized;

	if (Initialized)
		UseSelected();
}


function UseSelected()
{
	//local int NewTeam;
	local texture test;
GetPlayerOwner().UpdateURL("Team", "?Multiskin0="$SkinCombo1.GetValue2()$"?Multiskin1="$SkinCombo2.GetValue2()$"?Multiskin2="$SkinCombo3.GetValue2()$"?Multiskin3="$SkinCombo4.GetValue2()$"?Multiskin4="$SkinCombo5.GetValue2(), True);

	if (Initialized)
	{
		GetPlayerOwner().UpdateURL("Class", ClassCombo.GetValue2(), True);
		GetPlayerOwner().UpdateURL("Skin", "", True);
		GetPlayerOwner().UpdateURL("Face", "", True);
		//GetPlayerOwner().UpdateURL("Team", TeamCombo.GetValue2(), True);
		/*GetPlayerOwner().UpdateURL("Multiskin0", SkinCombo1.GetValue2(), True);
		GetPlayerOwner().UpdateURL("Multiskin1", SkinCombo2.GetValue2(), True);
		GetPlayerOwner().UpdateURL("Multiskin2", SkinCombo3.GetValue2(), True);
		GetPlayerOwner().UpdateURL("Multiskin3", SkinCombo4.GetValue2(), True);
		GetPlayerOwner().UpdateURL("Multiskin4", SkinCombo5.GetValue2(), True);*/
		//NewTeam = Int(TeamCombo.GetValue2());
		// if the same class as current class, change skin
		//if( ClassCombo.GetValue2() ~= String( GetPlayerOwner().Class ))
		//	GetPlayerOwner().ServerChangeSkin(SkinCombo1.GetValue2(), FaceCombo.GetValue2(), 255);

		//if( GetPlayerOwner().PlayerReplicationInfo.Team != NewTeam )
		//	GetPlayerOwner().ChangeTeam(NewTeam);
	}

	MeshWindow.SetMeshString(NewPlayerClass.Default.SelectionMesh);
	MeshWindow.ClearSkins();
	//NewPlayerClass.static.SetMultiSkin(MeshWindow.MeshActor, SkinCombo1.GetValue2(), FaceCombo.GetValue2(), 255);
	//MeshWindow.MeshActor.multiskins[0] = SkinCombo1.GetValue2(); 
	//test = texture(DynamicLoadObject("SoldierSkins.Gard1T_2", class'Texture'));

	//log("texture name "$SkinCombo1.GetValue2());
	//log("desperado "$skincombo1);
	MeshWindow.MeshActor.multiskins[0] = texture(DynamicLoadObject(SkinCombo1.GetValue2(), class'Texture'));
	MeshWindow.MeshActor.multiskins[1] = texture(DynamicLoadObject(SkinCombo2.GetValue2(), class'Texture'));
	MeshWindow.MeshActor.multiskins[2] = texture(DynamicLoadObject(SkinCombo3.GetValue2(), class'Texture'));
	MeshWindow.MeshActor.multiskins[3] = texture(DynamicLoadObject(SkinCombo4.GetValue2(), class'Texture'));
//log("face tex "$SkinCombo5.GetValue2());
//	MeshWindow.MeshActor.multiskins[4] = texture(DynamicLoadObject(SkinCombo5.GetValue2(), class'Texture'));
//talk tex
}

defaultproperties
{
     ControlOffset=25
     PlayerBaseClass="UnrealiPlayer"
     NameText="Name:"
     NameHelp="Set your player name."
     //TeamText="Team:"
   //  Teams(0)="Red"
   //  Teams(1)="Blue"
    // Teams(2)="Green"
   //  Teams(3)="Gold"
     //NoTeam="None"
  //   TeamHelp="Select the team you wish to play on."
     ClassText="Class:"
     ClassHelp="Select your player class."
     SkinText="Skin:"
   //  SkinHelp="Choose a skin for your player."
    // FaceText="Face:"
   //  FaceHelp="Choose a face for your player."
}
